﻿@model RoomEscapeCatalog.Models.RoomViewModel

@{
    ViewBag.Title = "New room";
}

@section styles {
    <link href="~/Content/Site-room-edit.css" rel="stylesheet" />
}

<div>
    @using (Html.BeginForm(null, null, FormMethod.Post, new { enctype = "multipart/form-data" }))
    {
        <div class="form-group">
            @Html.LabelFor(m => m.Room.Name, "Name")
            @Html.TextBoxFor(m => m.Room.Name, new { placeholder = "Room name", @class = "form-control", maxlength = "30", required = "true" })
        </div>
        <div class="form-group">
            @Html.LabelFor(m => m.Room.ShortDescription, "Short description")
            @Html.TextBoxFor(m => m.Room.ShortDescription, new { placeholder = "Short description", @class = "form-control", maxlength = "90", required = "true" })
        </div>
        <div class="form-group">
            @Html.LabelFor(m => m.LogoImageData, "Logo image")
            @Html.TextBoxFor(m => m.LogoImageData, new { type = "file", @class = "form-control-file", accept = "image/*", required = "true" })
        </div>
        <div class="form-group">
            @Html.LabelFor(m => m.Room.Overview, "Overview")
            @Html.TextAreaFor(m => m.Room.Overview, new { rows = "5", @class = "form-control" })
        </div>
        <div class="form-group">
            <div id="gallery">
                <div class="card">
                    <div class="card-header">
                        <a class="card-link card-toggle" data-toggle="collapse" href="#collapsible-container">
                            <i class="fas fa-images"></i> Gallery
                        </a>
                    </div>
                    <div id="collapsible-container" class="collapse" data-parent="#gallery">
                        <div class="card-body">
                            <div class="image-input-container">
                                @*@Html.TextBoxFor(m => m.GalleryImageData, new { type = "file", @class = "form-control-file", accept = "image/*" })*@
                                <input type="file" class="form-control-file" name="@nameof(Model.GalleryImageData)" accept="image/*" value="" />
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="form-group details">
            <div class="form-group details-grid">
                @*col 1*@
                <div class="d-flex"><i class="fas fa-clock"></i> Duration</div>
                @Html.TextBoxFor(m => m.Room.DurationMinutes, new { type = "number", min = "0", max = "180", placeholder = "Duration time (minutes)", @class = "form-control" })
                @*col 2*@
                <div class="d-flex"><i class="fas fa-user"></i> Group size</div>
                <div class="group-size">
                    @Html.TextBoxFor(m => m.Room.MinPlayers, new { type = "number", min = "1", max = "20", @class = "form-control", placeholder = "min" })
                    &nbsp;—&nbsp;
                    @Html.TextBoxFor(m => m.Room.MaxPlayers, new { type = "number", min = "1", max = "20", @class = "form-control", placeholder = "max" })
                </div>
                @*col 3*@
                <div class="d-flex"><i class="fas fa-calendar-alt"></i> Age restriction</div>
                @Html.TextBoxFor(m => m.Room.AgeRestriction, new { type = "number", min = "6", @class = "form-control", placeholder = "Minimum age" })
            </div>

            <div class="form-group details-grid">
                @*col 1*@
                <div class="d-flex"><i class="fas fa-shield-alt"></i> Difficulty</div>
                <div class="d-flex">
                    @Html.DropDownListFor(m => m.Room.Difficulty, new SelectList(Enumerable.Range(1, 5)), new { @class = "form-control" })
                    <span class="font-size-larger">&nbsp;/&nbsp;5</span>
                </div>
                @*col 2*@
                <div class="d-flex"><i class="fas fa-frown-open"></i> Creepiness</div>
                <div class="d-flex">
                    @Html.DropDownListFor(m => m.Room.Creepiness, new SelectList(Enumerable.Range(1, 5)), new { @class = "form-control" })
                    <span class="font-size-larger">&nbsp;/&nbsp;5</span>
                </div>
                @*col 3*@
                <div class="d-flex"><i class="fas fa-star"></i> Rating</div>
                <div class="d-flex">
                    @Html.DropDownListFor(m => m.Room.Rating, new SelectList(Enumerable.Range(1, 5)), new { @class = "form-control" })
                    <span class="font-size-larger">&nbsp;/&nbsp;5</span>
                </div>
            </div>
        </div>

        <div class="form-group details-grid contact-info">
            @*col 1*@
            <div class="d-flex"><i class="fas fa-phone"></i> Phone</div>
            @Html.TextBoxFor(m => m.Room.Phone, new { @class = "form-control" })
            @*col 2*@
            <div class="d-flex"><i class="fas fa-at"></i> Email</div>
            @Html.TextBoxFor(m => m.Room.Email, new { type = "email", @class = "form-control" })
            @*col 3*@
            <div class="d-flex"><i class="fas fa-map-marked-alt"></i> Address</div>
            @Html.TextBoxFor(m => m.Room.Address, new { @class = "form-control" })
        </div>

        <div class="form-group btn-container">
            <input type="submit" name="submit" value="Save" class="btn btn-primary" />
            @Html.ActionLink(
                "Cancel",
                actionName: nameof(RoomEscapeCatalog.Controllers.AdminController.Index),
                controllerName: "Admin",
                routeValues: null,
                htmlAttributes: new { @class = "btn btn-secondary" })
        </div>
    }
</div>

@section scripts {
    <script>
        let imageInputContainer = $(".image-input-container").first();
        imageInputContainer.change((e) => {

            if (e.target.getAttribute("type") != "file") {
                return;
            }

            let fileInputs = $("input[type='file']", imageInputContainer)
            let emptyInputExists = false;
            for (var elem of fileInputs) {
                console.log(elem)
                console.log(elem.files)

                if (elem.files.length == 0) {
                    emptyInputExists = true;
                    break;
                }
            }

            if (emptyInputExists) {
                return;
            }

            let newFileInput = $(`<input type="file" class="form-control-file" name="@nameof(Model.GalleryImageData)" accept="image/*" value="" />`);
            imageInputContainer.append(newFileInput);
        })
    </script>
}
